var _dec, _dec2, _class, _class2, _descriptor;

function _initializerDefineProperty(target, property, descriptor, context) { if (!descriptor) return; Object.defineProperty(target, property, { enumerable: descriptor.enumerable, configurable: descriptor.configurable, writable: descriptor.writable, value: descriptor.initializer ? descriptor.initializer.call(context) : void 0 }); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) { var desc = {}; Object.keys(descriptor).forEach(function (key) { desc[key] = descriptor[key]; }); desc.enumerable = !!desc.enumerable; desc.configurable = !!desc.configurable; if ('value' in desc || desc.initializer) { desc.writable = true; } desc = decorators.slice().reverse().reduce(function (desc, decorator) { return decorator(target, property, desc) || desc; }, desc); if (context && desc.initializer !== void 0) { desc.value = desc.initializer ? desc.initializer.call(context) : void 0; desc.initializer = undefined; } if (desc.initializer === void 0) { Object.defineProperty(target, property, desc); desc = null; } return desc; }

function _initializerWarningHelper(descriptor, context) { throw new Error('Decorating class property failed. Please ensure that ' + 'proposal-class-properties is enabled and runs after the decorators transform.'); }

import { CanvasConfig } from '@antv/g';
import { inject, injectable } from 'inversify';
import { isString } from '@antv/util';
import { setDOMSize } from './utils/dom';
export var Canvas2DContextService = (_dec = injectable(), _dec2 = inject(CanvasConfig), _dec(_class = (_class2 = /*#__PURE__*/function () {
  function Canvas2DContextService() {
    _classCallCheck(this, Canvas2DContextService);

    this.$container = void 0;
    this.$canvas = void 0;
    this.dpr = void 0;
    this.context = void 0;

    _initializerDefineProperty(this, "canvasConfig", _descriptor, this);
  }

  _createClass(Canvas2DContextService, [{
    key: "init",
    value: function init() {
      var _this$canvasConfig = this.canvasConfig,
          container = _this$canvasConfig.container,
          width = _this$canvasConfig.width,
          height = _this$canvasConfig.height; // create container

      this.$container = isString(container) ? document.getElementById(container) : container;

      if (this.$container) {
        // create canvas
        var $canvas = document.createElement('canvas');
        this.context = $canvas.getContext('2d');
        this.$container.appendChild($canvas);

        if (!this.$container.style.position) {
          this.$container.style.position = 'relative';
        }

        this.$canvas = $canvas;
        var dpr = window.devicePixelRatio || 1;
        dpr = dpr >= 1 ? Math.ceil(dpr) : 1;
        this.dpr = dpr;
        this.resize(width, height);
      }
    }
  }, {
    key: "getContext",
    value: function getContext() {
      return this.context;
    }
  }, {
    key: "getDomElement",
    value: function getDomElement() {
      return this.$canvas;
    }
  }, {
    key: "getDPR",
    value: function getDPR() {
      return this.dpr;
    }
  }, {
    key: "getBoundingClientRect",
    value: function getBoundingClientRect() {
      var _this$$canvas;

      return (_this$$canvas = this.$canvas) === null || _this$$canvas === void 0 ? void 0 : _this$$canvas.getBoundingClientRect();
    }
  }, {
    key: "destroy",
    value: function destroy() {
      if (this.$container && this.$canvas && this.$canvas.parentNode) {
        // destroy context
        this.$container.removeChild(this.$canvas);
      }
    }
  }, {
    key: "resize",
    value: function resize(width, height) {
      if (this.$canvas) {
        // set canvas width & height
        this.$canvas.width = this.dpr * width;
        this.$canvas.height = this.dpr * height; // set CSS style width & height

        setDOMSize(this.$canvas, width, height);
      }
    }
  }, {
    key: "applyCursorStyle",
    value: function applyCursorStyle(cursor) {
      if (this.$container) {
        this.$container.style.cursor = cursor;
      }
    }
  }]);

  return Canvas2DContextService;
}(), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "canvasConfig", [_dec2], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: null
})), _class2)) || _class);