"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Renderer = void 0;

var _g = require("@antv/g");

var _gPluginDomInteraction = require("@antv/g-plugin-dom-interaction");

var _gPluginCanvasRenderer = require("@antv/g-plugin-canvas-renderer");

var _gPluginCanvasPicker = require("@antv/g-plugin-canvas-picker");

var _gPluginHtmlRenderer = require("@antv/g-plugin-html-renderer");

var _ContextRegisterPlugin = require("./ContextRegisterPlugin");

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var Renderer = /*#__PURE__*/function (_AbstractRenderer) {
  _inherits(Renderer, _AbstractRenderer);

  var _super = _createSuper(Renderer);

  function Renderer(config) {
    var _this;

    _classCallCheck(this, Renderer);

    _this = _super.call(this, config); // register Canvas2DContext

    _this.registerPlugin(new _ContextRegisterPlugin.ContextRegisterPlugin()); // enable rendering with Canvas2D API


    _this.registerPlugin(new _gPluginCanvasRenderer.Plugin());

    _this.registerPlugin(new _gPluginDomInteraction.Plugin()); // enable picking with Canvas2D API


    _this.registerPlugin(new _gPluginCanvasPicker.Plugin()); // render HTML component


    _this.registerPlugin(new _gPluginHtmlRenderer.Plugin());

    return _this;
  }

  return Renderer;
}(_g.AbstractRenderer);

exports.Renderer = Renderer;